#include <assert.h>
#include "opengl.h"
#include "game.h"
#include "screen.h"

int win_width, win_height;
float win_aspect;
long frame_time;
float frame_dt;

bool game_init()
{
	if(init_opengl() == -1) {
		return false;
	}

	if(!init_screens()) {
		return false;
	}

	glEnable(GL_MULTISAMPLE);
	glEnable(GL_FRAMEBUFFER_SRGB);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);

	active_screen->start();
	return true;
}

void game_cleanup()
{
	cleanup_screens();
}

void game_draw()
{
	active_screen->draw();

	assert(glGetError() == GL_NO_ERROR);
}

void game_reshape(int x, int y)
{
	active_screen->reshape(x, y);
}

void game_keyboard(int key, bool pressed)
{
	if(pressed) {
		switch(key) {
		case 17:
			/* for some inexplicable reason freeglut seems to produce key
			 * 17 for ctrl-q on both X and windows.
			 */
			game_quit();
			return;

		default:
			break;
		}
	}

	active_screen->keyboard(key, pressed);
}

void game_mbutton(int bn, bool pressed, int x, int y)
{
	active_screen->mbutton(bn, pressed, x, y);
}

void game_mmotion(int x, int y)
{
	active_screen->mmotion(x, y);
}

void game_mwheel(int dir, int x, int y)
{
	active_screen->mwheel(dir, x, y);
}
