#include "screen.h"
#include "game.h"

ScreenBase *active_screen;
MenuScreen *scr_menu;
GameScreen *scr_game;

bool init_screens()
{
	scr_menu = new MenuScreen;
	if(!scr_menu->init()) {
		return false;
	}

	scr_game = new GameScreen;
	if(!scr_game->init()) {
		return false;
	}

	push_screen(scr_menu);
	//push_screen(scr_game);
	return true;
}

void cleanup_screens()
{
	scr_game->destroy();
	delete scr_game;

	scr_menu->destroy();
	delete scr_menu;
}

void push_screen(ScreenBase *scr)
{
	scr->next = active_screen;
	active_screen = scr;

	scr->reshape(win_width, win_height);
	scr->start();
}

void pop_screen()
{
	ScreenBase *scr = active_screen;
	active_screen = scr->next;

	scr->stop();
}


ScreenBase::ScreenBase()
{
	next = 0;
}

ScreenBase::~ScreenBase()
{
}

bool ScreenBase::init()
{
	return true;
}

void ScreenBase::destroy()
{
}

void ScreenBase::start()
{
}

void ScreenBase::stop()
{
}


void ScreenBase::reshape(int x, int y)
{
}


void ScreenBase::keyboard(int key, bool pressed)
{
}

void ScreenBase::mbutton(int bn, bool pressed, int x, int y)
{
}

void ScreenBase::mmotion(int x, int y)
{
}

void ScreenBase::mwheel(int dir, int x, int y)
{
}
